//Program.c
#include "Array.h"
#include "Book.h"
void View_Array(Array *arr)
{
    Book *book = 0;
    Iterator seek = Array_Begin(arr);
    Iterator end = Array_End(arr);
    
    printf("-----  -----\n");
    for(   ;seek!=end;seek++)
    {
        book = (Book *)(*seek);
        if(book)
        {
            Book_View(book);
        }
    }	
}
void SimulEnd(Array *arr)
{
    Book *book = 0;
    Iterator seek = Array_Begin(arr);
    Iterator end = Array_End(arr);
    
    for(   ;seek!=end;seek++)
    {
        book = (Book *)(*seek);
        if(book)
        {
            Delete_Book(book);
        }
    }
    Delete_Array(arr);
}
void Simul_Find(Array *arr,const char *title)
{
    Book *book = 0;
    Iterator seek = Array_Begin(arr);
    Iterator end = Array_End(arr);
    
    for(   ;seek!=end;seek++)
    {
        book = (Book *)(*seek);
        if(book && (Book_CompareTitle(book,title)==0))
        {
            printf("˻ :");
            Book_View(book);
            return;
        }
    }
    printf("<%s> å ã  ϴ.\n",title);
}
void Simul_Remove(Array *arr,const char *title)
{
    Book *book = 0;
    Iterator seek = Array_Begin(arr);
    Iterator end = Array_End(arr);
    
    for(   ;seek!=end;seek++)
    {
        book = (Book *)(*seek);
        if(book && (Book_CompareTitle(book,title)==0))
        {
            Array_Erase(arr,seek);
            Delete_Book(book);
            printf(" !\n");
            return;
        }
    }
    printf("<%s> å ã  ϴ.\n",title);
}
void Simul_Seq()
{
    Array *arr = New_Array();
    Array_PushBack(arr,New_Book("C","ȫ浿",10));
    Array_PushBack(arr,New_Book("C++","",20));
    Array_PushBack(arr,New_Book("ڷᱸ","豸",5));
    Array_PushBack(arr,New_Book("˰","̼",9));
    Array_PushBack(arr,New_Book("","",13));
    View_Array(arr);
    Simul_Find(arr,"C");
    Simul_Find(arr,"̵̷");
    Simul_Remove(arr,"ڷᱸ");
    View_Array(arr);
    SimulEnd(arr);	
}

void Simul_OrderAdd(Array *arr,Book *book)
{	
    Book *stored_book = 0;
    Iterator seek = Array_Begin(arr);
    Iterator end = Array_End(arr);
    
    for(   ;seek!=end;seek++)
    {
        stored_book = (Book *)(*seek);
        if(stored_book && (Book_CompareAuthor(stored_book,book->author)>=0))
        {
            break;
        }
    }	
    Array_Insert(arr,seek,book);
}
void Simul_Order()
{
    Array *arr = New_Array();
    
    Simul_OrderAdd(arr,New_Book("C","ȫ浿",10));
    Simul_OrderAdd(arr,New_Book("C++","",20));
    Simul_OrderAdd(arr,New_Book("ڷᱸ","豸",5));
    Simul_OrderAdd(arr,New_Book("˰","̼",9));
    Simul_OrderAdd(arr,New_Book("","",13));
    View_Array(arr);
    Simul_Find(arr,"C");
    Simul_Find(arr,"̵̷");
    Simul_Remove(arr,"ڷᱸ");
    View_Array(arr);
    SimulEnd(arr);
}

void Simul_FindNum(Array *arr,int bnum)
{
    Book *book = 0;
    book = (Book *)Array_GetAt(arr,bnum-1);
    if(book)
    {
        printf("˻ :");
        Book_View(book);			
    }
    else
    {
        printf("<%d> å ã  ϴ.\n",bnum);
    }
}
void Simul_RemoveNum(Array *arr,int bnum)
{	
    Book *book = 0;
    book = (Book *)Array_GetAt(arr,bnum-1);
    if(book)
    {		
        Delete_Book(book);			
        Array_SetAt(arr,bnum-1,0);
    }
    else
    {
        printf("<%d> å ã  ϴ.\n",bnum);
    }
}
void Simul_Index()
{
    Array *arr = New_Array();
    Array_SetSize(arr,100,0);	
    Array_SetAt(arr,9,New_Book("C","ȫ浿",10));
    Array_SetAt(arr,19,New_Book("C++","",20));
    Array_SetAt(arr,4,New_Book("ڷᱸ","豸",5));
    Array_SetAt(arr,8,New_Book("˰","̼",9));
    Array_SetAt(arr,12,New_Book("","",13));
    View_Array(arr);
    Simul_FindNum(arr,20);
    Simul_FindNum(arr,21);	
    Simul_RemoveNum(arr,9);
    View_Array(arr);
    SimulEnd(arr);
}
int main()
{
    Simul_Seq();
    Simul_Order();
    Simul_Index();
    return 0;
}